(require "foreign-nb.scm")(unsafe!)

(define lib (ffi-lib "test"))

(define test1   (get-ffi-obj "test1" lib (_fun _int -> _int)))
(define test1nb (get-ffi-obj/nb "test1" lib (_fun _int -> _int)))

;(define test2   (get-ffi-obj "test2" lib (_fun _int -> _int)))
(define test2nb (get-ffi-obj/nb "test2" lib (_fun _int -> _int)))


(define (tst n)
  (if (> n 0)
    (begin
      (display (format "scheme:tst: iteration ~a, sleeping 0.5~%" n))
      (sleep 0.5)
      (+ n (tst (- n 1))))
    n))

(define (test2a n)
  (let ((r1 #f)
        (r2 #f))
    (let ((t (thread (lambda () (display (format "result of tst: ~a ~%" (begin (set! r1 (tst n)) r1)))))))
       (display (format "n=~a~%" n))
       (set! r2 (test2nb n))
       (thread-wait t))
       (values r1 r2)))

(define (test2b n)
  (let ((r1 #f)
        (r2 #f)
        (r3 #f)
        (r4 #f))
    (let ((t1 (thread (lambda () (display (format "result of tst: ~a ~%" (begin (set! r1 (tst n)) r1))))))
          (t2 (thread (lambda () (set! r3 (test2nb (+ n 1))))))
	  (t3 (thread (lambda () (set! r4 (test2nb (- n 1)))))))
       (display (format "n=~a~%" n))
       (set! r2 (test2nb n))
       (thread-wait t1)
       (thread-wait t2)
       (thread-wait t3)
       (values r1 r2 r3 r4))))
 
